<template>
  <b-container fluid class="home">
    <div>
      <h1 class="display-3">Welcome <font color="#497774">{{ user.username }}</font> </h1>
      <p class="lead">This is the verification page of <b>Platone Blockchain Access Platform</b></p>
    </div>
    <div>
       <b-row>
          <b-col>
            <b-form-input v-model="text" placeholder="Enter your transaction Hash"></b-form-input>
            <b-button v-on:click="getCertification(text)" class="b-search">Search</b-button>
          </b-col>
       </b-row>
    </div>
    <div v-if="result">
      <b-card class="card">
        <h4>Certified dataset</h4>
        <b-row>
          <b-col><b>Date From:</b> {{ result.dataset.dateFrom | formatDate }}</b-col>
          <b-col><b>Date To:</b> {{ result.dataset.dateTo | formatDate }}</b-col>
          <b-col><b>Owner:</b> {{ result.owner }}</b-col>
        </b-row>
        <b-row>
          <b-col>
             <b-button class="b-search" v-on:click="balQuery(result.dataset.dateFrom, result.dataset.dateTo, result.owner)">Search</b-button>
          </b-col>
       </b-row>
      </b-card>
     </div>
    <div v-if="loading && !cassandraResult">
      <b-spinner style="width: 5rem; height: 5rem; margin-top:20px;" label="Loading..."></b-spinner>
    </div>
     <b-container class="bv-example-row" fluid  v-if="cassandraResult">
      <b-card>
        <h4>Results</h4>
        <b-row>
            <div v-if="resultToShow" class="json">
              <b-col>
                <h4 class="center">Raw Data</h4>
                <b-card>
                    <vue-json-pretty :data="resultToShow"></vue-json-pretty>
                </b-card>
              </b-col>
            </div>
            <div v-if="hash" class="hash">
              <b-col>
                <h4>Hashed Data</h4>
                <b-card>
                  <b-alert show :variant="alert">
                    <h4>Generated hash</h4>
                      {{hash}}
                    <h4 class="verifiedHash">Verify hash</h4>
                    <b-form-input v-on:change="isVerified()" v-model="vHash" placeholder="Insert hash for verification"></b-form-input>
                  </b-alert>
                </b-card>
              </b-col>
            </div>
          </b-row>
        </b-card>
      </b-container>
 </b-container>

</template>

<style>
  input {
    text-align: center;
  }
  .home {
    text-align: center;
  }
  .home .lead {
    font-weight: 200;
    font-size: 1.5rem;
  }
  .b-search {
    margin-top: 10px;
    background-color: #497774;
  }
  .card {
    margin-top: 20px;
  }
  .json {
    text-align: left;
    width: 50%;
  }
  .hash {
    width: 50%;
  }
  .verifiedHash {
    margin-top: 40px;
  }
  .center {
    text-align: center;
  }
</style>

<script>
import HomeService from '@/services/HomeService'

export default {
  name: 'home',
  data () {
    return {
      user: this.$session.get('user'),
      result: null,
      cassandraResult: null,
      hash: null,
      text: '',
      vHash: null,
      alert: 'light',
      loading: false
    }
  },
  methods: {
    async getCertification (transaction) {
      const response = await HomeService.getCertification(transaction)
      console.log('Response ' + JSON.stringify(response.data))
      this.result = response.data[0]
    },
    async cassandraQuery (dateFrom, dateTo, owner) {
      this.loading = true
      const response = await HomeService.cassandraQuery({dateFrom, dateTo, owner})
      console.log('Response ' + JSON.stringify(response.data))
      this.cassandraResult = response.data.meterReadings._rs.rows
      this.resultToShow = this.cassandraResult.slice(0, 10)
      this.hash = response.data.hash
    },
    async balQuery (dateFrom, dateTo, owner) {
      this.loading = true
      const response = await HomeService.balQuery({dateFrom, dateTo, owner})
      console.log('Response ' + JSON.stringify(response.data))
      this.balResult = response.data.meterReadings._rs.rows
      this.resultToShow = this.balResult.slice(0, 10)
      this.hash = response.data.hash
    },
    isVerified () {
      console.log('VERIFIED')
      if (this.vHash === this.hash) {
        this.alert = 'success'
      } else {
        this.alert = 'danger'
      }
    }
  }
}
</script>
